package protocolsupport.protocol.packet.middle.serverbound.handshake;

import protocolsupport.protocol.ConnectionImpl;
import protocolsupport.protocol.packet.ServerBoundPacket;
import protocolsupport.protocol.packet.middle.ServerBoundMiddlePacket;
import protocolsupport.protocol.packet.middleimpl.ServerBoundPacketData;
import protocolsupport.protocol.serializer.StringSerializer;
import protocolsupport.protocol.serializer.VarNumberSerializer;
import protocolsupport.protocol.utils.ProtocolVersionsHelper;
import protocolsupport.utils.recyclable.RecyclableCollection;
import protocolsupport.utils.recyclable.RecyclableSingletonList;

public abstract class MiddleSetProtocol extends ServerBoundMiddlePacket {

	public MiddleSetProtocol(ConnectionImpl connection) {
		super(connection);
	}

	protected String hostname;
	protected int port;
	protected int nextState;

	@Override
	public RecyclableCollection<ServerBoundPacketData> toNative() {
		ServerBoundPacketData creator = ServerBoundPacketData.create(ServerBoundPacket.HANDSHAKE_START);
		VarNumberSerializer.writeVarInt(creator, ProtocolVersionsHelper.LATEST_PC.getId());
		StringSerializer.writeString(creator, ProtocolVersionsHelper.LATEST_PC, hostname);
		creator.writeShort(port);
		VarNumberSerializer.writeVarInt(creator, nextState);
		return RecyclableSingletonList.create(creator);
	}

}
